/*
 * Created by JFormDesigner on Fri Oct 12 01:38:05 CEST 2007
 */

package ti.mashine.urm.graphic;

import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.text.MessageFormat;
import java.text.NumberFormat;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Observable;
import java.util.Observer;
import java.util.TreeMap;
import java.util.Vector;

import javax.swing.*;
import javax.swing.event.*;
import javax.swing.plaf.ButtonUI;
import javax.swing.plaf.basic.BasicBorders;
import javax.swing.plaf.basic.BasicBorders.RolloverButtonBorder;
import javax.swing.plaf.metal.MetalBorders;
import javax.swing.table.DefaultTableColumnModel;
import javax.swing.table.TableColumn;
import javax.swing.text.BadLocationException;

import sr.co.visiongulp.swing.MyTableModel;
import sun.reflect.generics.visitor.Reifier;
import ti.mashine.urm.ProgramConstants;
import ti.mashine.urm.ProgramState;
import ti.mashine.urm.UrmController;
import ti.mashine.urm.UrmException;
import ti.mashine.urm.UrmModel;
import ti.mashine.urm.instructions.Instruction;
import ti.mashine.urm.instructions.Procedure;
import ti.mashine.urm.register.Register;

import com.jgoodies.forms.factories.*;
import com.jgoodies.forms.layout.*;

import sr.co.visiongulp.swing.CurrentLineHighlighter;
import sr.co.visiongulp.swing.MyJOptionPane;
import sr.co.visiongulp.swing.MyJTable;
import sr.co.visiongulp.swing.MyButton;

/**
 * @author aca kare
 */
public class UrmPanel extends JPanel implements Observer {
    /**
         * 
         */
    private static final long serialVersionUID = -2601445439615090023L;

    private static UrmPanel _instance;

    static UrmController controller;

    private JList procedureHelperList;

    private UrmPanel(UrmModel m) {
	super();
	ProgramState.deserialize();
	controller = new UrmController(m, this);
	initComponents();
	initMyThings();
	controller.getModel().masterRefresh();
	updateSavedProcedureView();
    }

    static public UrmPanel getInstance(UrmModel m) {
	if ((_instance != null && m != getController().getModel()) || _instance == null)
	    _instance = new UrmPanel(m);
	return _instance;
    }

    private void initMyThings() {
	codeArea.addCaretListener(new CurrentLineHighlighter(Color.red));
	// codeArea.setText(ProjectConstants.SAMPLE_PROGRAM);
	// DefaultCellEditor cellEditor=new DefaultCellEditor(new JTextField());
	registerTable.setModel(new MyTableModel());
	registerTable.setCellSelectionEnabled(true);
	//registerTable.setFillsViewportHeight(true);
	registerTable.setRowHeight(ProgramConstants.REGISTER_HEIGHT);

	codeArea.setAutoscrolls(true);
	codeArea.setSelectionColor(Color.yellow);
	codeArea.setSelectedTextColor(Color.black);
	codeArea.setBackground(new Color(216, 228, 248));
	procedureHelperList = new JList();
	procedureHelperList.setSize(200, 20);
	procedureHelperList.addListSelectionListener(new ListSelectionListener() {
	    public void valueChanged(ListSelectionEvent arg0) {
		if (arg0.getValueIsAdjusting())
		    procedureHelperListValueChanged(arg0);
	    }

	});

	saveButton.setPreferredSize(new Dimension(30, 30));
	parseButton.setPreferredSize(new Dimension(30, 30));
	runButton.setPreferredSize(new Dimension(30, 30));
	nextStepButton.setPreferredSize(new Dimension(30, 30));
	previousStep.setPreferredSize(new Dimension(30, 30));
	setRegisterButton.setPreferredSize(new Dimension(30, 30));
	helpButton.setPreferredSize(new Dimension(30, 30));
	infoButton.setPreferredSize(new Dimension(30, 30));
	deleteProgramButton.setPreferredSize(new Dimension(30, 30));
	saveButton.setBorder(MetalBorders.getButtonBorder());
	parseButton.setBorder(MetalBorders.getButtonBorder());
	runButton.setBorder(MetalBorders.getButtonBorder());
	nextStepButton.setBorder(MetalBorders.getButtonBorder());
	previousStep.setBorder(MetalBorders.getButtonBorder());
	setRegisterButton.setBorder(MetalBorders.getButtonBorder());
	helpButton.setBorder(MetalBorders.getButtonBorder());
	infoButton.setBorder(MetalBorders.getButtonBorder());
	deleteProgramButton.setBorder(MetalBorders.getButtonBorder());
    }

    private void procedureHelperListValueChanged(ListSelectionEvent arg0) {
	int start = arg0.getFirstIndex();
	int end = arg0.getLastIndex();
	if (end == start) {
	    String temp = procedureHelperList.getModel().getElementAt(end).toString();
	    String procedureName = temp.substring(0, temp.indexOf("("));
	    Procedure proc = ProgramState.getInstance().getUrmProgram(procedureName);
	    int pos = codeArea.getCaretPosition();
	    int row = -1;
	    try {
		row = codeArea.getLineOfOffset(pos);
	    } catch (BadLocationException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	    }
	    System.out.println("Setting instruction " + row);
	    if (row > -1 && row < ProgramConstants.INSTRUCTION_ARRAY_SIZE)
		controller.setInstructionAt(row, proc);

	}
    }

    private void parseButtonActionPerformed(ActionEvent e) {
	try {
	    controller.parseInput(codeArea.getText());
	} catch (UrmException e1) {
	    errorLabel.setText(e1.getMessage());
	    e1.printStackTrace();
	}
    }

    private void setRegisterButtonActionPerformed(ActionEvent e) {
	MyTableModel tableModel = (MyTableModel) registerTable.getModel();
	Register register = new Register(ProgramConstants.REGISTER_SIZE);
	for (int i = 0; i < registerTable.getColumnCount(); i++) {
	    try {
		register.setValueAt(i, Integer.valueOf(tableModel.getValueAt(0, i).toString()), ProgramConstants.RUN_STEP_BY_STEP);
	    } catch (NumberFormatException ne) {
		errorLabel.setText(ne.toString() + "\n" + "Proverite registar " + ProgramConstants.REGISTER_PREFIX + i);
		return;
	    }
	}
	controller.getModel().setRegister(register);
	controller.getModel().getRegister().addObserver(this);
    }

    private void previousStepActionPerformed(ActionEvent e) {
	if (controller.stepBack(this)) {
	    // TODO this shouldn't be done from here
	    controller.getModel().getRegister().addObserver(this);
	    updateModel();
	}
    }

    private void nextStepButtonActionPerformed(ActionEvent e) {
	try {
	    controller.nextInstructionExecute();
	} catch (UrmException e1) {
	    errorLabel.setText(e1.toString());
	}
    }

    private void runButtonActionPerformed(ActionEvent e) {
	try {
	    controller.fullExecute();
	} catch (UrmException e1) {
	    errorLabel.setText(e1.toString());
	}
    }

    private void codeAreaCaretUpdate(CaretEvent e) {
	procedureHelperList.setVisible(false);

    }

    private void saveButtonActionPerformed(ActionEvent e) {
	if(!controller.getModel().isCompiled()){
	    JOptionPane.showMessageDialog(this, "Pre cuvanja morate iskompajlirati!");
	    return;
	}
	Vector<String> procData;
	Vector<String> procLabels = new Vector<String>(3);
	procLabels.add("Ime programa: ");
	procLabels.add("Broj argum: ");
	procLabels.add("Smisao programa: ");
	procData = MyJOptionPane.showInputDialog(procLabels);
	if (procData != null) {
	    try {
		if (procData.get(0) != null && procData.get(1) != null && Integer.valueOf(procData.get(1)) != null && procData.get(2) != null) {
		    controller.saveProcedure(procData.get(0), Integer.valueOf(procData.get(1)), procData.get(2));
		    // TODO should be changed in the MVC pattern way.
		    // ProgramState
		    // as observer of
		    // controller, notifying back to the update method of
		    // this
		    // class,
		    // but works good for now
		    updateSavedProcedureView();
		} else
		    errorLabel.setText("Niste podesili dobro trazena polja za cuvanje programa. Sva 3 su obavezna");
	    } catch (UrmException ue) {
		errorLabel.setText(ue.getMessage());
	    }
	}
    }

    private void openMenuActionPerformed(ActionEvent e) {
	// TODO add your code here
    }

    private void openMenuFocusGained(FocusEvent e) {
	// TODO add your code here
    }

    private void codeAreaKeyPressed(KeyEvent e) {
	controller.getModel().setCompiled(false);
	if (e.isControlDown()) {
	    if (e.getKeyCode() == KeyEvent.VK_SPACE) {
		TreeMap<String, Procedure> urmPrograms = controller.getUrmPrograms();
		Iterator<String> it = urmPrograms.keySet().iterator();
		Vector<String> messages = new Vector<String>(urmPrograms.size());
		String temp;
		StringBuffer tempMessage;
		// collecting info on stored procedures
		int k = 0;
		while (it.hasNext()) {
		    temp = it.next();
		    tempMessage = new StringBuffer();
		    tempMessage.append(temp + "(");
		    int i;
		    for (i = 0; i < urmPrograms.get(temp).getArgs().length - 1; i++) {
			tempMessage.append("arg" + i + ", ");
		    }
		    if (urmPrograms.get(temp).getArgs().length!=0)
			tempMessage.append("arg" + i);
		    tempMessage.append(") %" + urmPrograms.get(temp).getDescription());
		    messages.add(tempMessage.toString());
		    k++;
		}
		// procedureHelperList
		procedureHelperList = new JList();
		procedureHelperList.setSize(300, 17 * messages.size());
		procedureHelperList.addListSelectionListener(new ListSelectionListener() {
		    public void valueChanged(ListSelectionEvent arg0) {
			if (arg0.getValueIsAdjusting())
			    procedureHelperListValueChanged(arg0);
		    }

		});
		procedureHelperList.setListData(messages);
		Point caretPos = codeArea.getCaret().getMagicCaretPosition();
		codeArea.add(procedureHelperList);
		procedureHelperList.setVisible(true);
		procedureHelperList.setLocation(caretPos);
	    } else
		errorLabel.setText("Sa ctrl+space ubacujete automatski jednu od biblioteckih procedura.");
	}
    }

    private void helpButtonActionPerformed(ActionEvent e) {
	JOptionPane.showMessageDialog(this, ProgramConstants.SAMPLE_PROGRAM, "Usage", JOptionPane.INFORMATION_MESSAGE);

    }

    private void deleteProgramButtonActionPerformed(ActionEvent e) {
	if (JOptionPane.showConfirmDialog(this, "Da li ste sigurni da zelite da obrisete " + ProgramState.getInstance().getCurrentWorkingProgram() + " proceduru?") == JOptionPane.OK_OPTION) {
	    try {
		controller.deleteProcedure(ProgramState.getInstance().getCurrentWorkingProgram());
		Procedure proc = getController().openProcedure(ProgramConstants.NEW_PROGRAM_TOKEN);
		controller.setModel(new UrmModel(proc, new Register(ProgramConstants.REGISTER_SIZE)), getInstance(getController().getModel()));
		controller.getModel().masterRefresh();controller.getModel().masterRefresh();
	    } catch (UrmException e1) {
		// TODO Auto-generated catch block
		e1.printStackTrace();
	    }
	}
    }

    private void codeAreaPropertyChange(PropertyChangeEvent e) {
    	// TODO add your code here
    }

    private void codeAreaInputMethodTextChanged(InputMethodEvent e) {
    	// TODO add your code here
    }

    private void codeAreaVetoableChange(PropertyChangeEvent e)
    	throws PropertyVetoException
    {
    	// TODO add your code here
    }

 


    

    private void initComponents() {
	// JFormDesigner - Component initialization - DO NOT MODIFY
	// //GEN-BEGIN:initComponents
	// Generated using JFormDesigner Evaluation license - aca kare
	DefaultComponentFactory compFactory = DefaultComponentFactory.getInstance();
	menuBar1 = new JMenuBar();
	openMenu = new JMenu();
	saveButton = new JButton();
	parseButton = new JButton();
	runButton = new JButton();
	previousStep = new JButton();
	nextStepButton = new JButton();
	deleteProgramButton = new JButton();
	currentProgramLabel = new JLabel();
	helpButton = new JButton();
	infoButton = new JButton();
	separator3 = compFactory.createSeparator("program code");
	scrollPane1 = new JScrollPane();
	codeArea = new JTextArea();
	errorLabel = compFactory.createLabel("");
	separator1 = compFactory.createSeparator("register");
	scrollPane3 = new JScrollPane();
	registerTable = new JTable();
	setRegisterButton = new JButton();
	CellConstraints cc = new CellConstraints();

	//======== this ========

	// JFormDesigner evaluation mark
	setBorder(new javax.swing.border.CompoundBorder(
		new javax.swing.border.TitledBorder(new javax.swing.border.EmptyBorder(0, 0, 0, 0),
			"JFormDesigner Evaluation", javax.swing.border.TitledBorder.CENTER,
			javax.swing.border.TitledBorder.BOTTOM, new java.awt.Font("Dialog", java.awt.Font.BOLD, 16),
			java.awt.Color.red), getBorder())); addPropertyChangeListener(new java.beans.PropertyChangeListener(){public void propertyChange(java.beans.PropertyChangeEvent e){if("border".equals(e.getPropertyName()))throw new RuntimeException();}});

	setLayout(new FormLayout(
		new ColumnSpec[] {
			FormFactory.PREF_COLSPEC,
			FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
			FormFactory.PREF_COLSPEC,
			FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
			FormFactory.PREF_COLSPEC,
			FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
			FormFactory.PREF_COLSPEC,
			FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
			FormFactory.PREF_COLSPEC,
			FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
			FormFactory.PREF_COLSPEC,
			FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
			new ColumnSpec(ColumnSpec.FILL, Sizes.DEFAULT, FormSpec.DEFAULT_GROW),
			FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
			FormFactory.PREF_COLSPEC,
			FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
			FormFactory.PREF_COLSPEC,
			FormFactory.LABEL_COMPONENT_GAP_COLSPEC,
			FormFactory.DEFAULT_COLSPEC
		},
		new RowSpec[] {
			FormFactory.DEFAULT_ROWSPEC,
			FormFactory.LINE_GAP_ROWSPEC,
			FormFactory.DEFAULT_ROWSPEC,
			FormFactory.LINE_GAP_ROWSPEC,
			FormFactory.DEFAULT_ROWSPEC,
			FormFactory.LINE_GAP_ROWSPEC,
			new RowSpec(RowSpec.FILL, Sizes.dluY(81), FormSpec.DEFAULT_GROW),
			FormFactory.LINE_GAP_ROWSPEC,
			FormFactory.DEFAULT_ROWSPEC,
			FormFactory.LINE_GAP_ROWSPEC,
			FormFactory.DEFAULT_ROWSPEC,
			FormFactory.LINE_GAP_ROWSPEC,
			new RowSpec(RowSpec.FILL, Sizes.dluY(54), FormSpec.NO_GROW),
			FormFactory.LINE_GAP_ROWSPEC,
			FormFactory.DEFAULT_ROWSPEC
		}));
	((FormLayout)getLayout()).setColumnGroups(new int[][] {{3, 5, 7, 9, 11, 15, 17}});

	//======== menuBar1 ========
	{

		//======== openMenu ========
		{
			openMenu.setText("otvori");
			openMenu.setIcon(new ImageIcon("resized icons\\Open_Folder.png"));
			openMenu.setToolTipText("otvori sacuvanu proceduru");
			openMenu.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					openMenuActionPerformed(e);
				}
			});
			openMenu.addFocusListener(new FocusAdapter() {
				@Override
				public void focusGained(FocusEvent e) {
					openMenuFocusGained(e);
				}
			});
		}
		menuBar1.add(openMenu);
	}
	add(menuBar1, cc.xy(1, 1));

	//---- saveButton ----
	saveButton.setIcon(new ImageIcon("resized icons\\saveFile.png"));
	saveButton.setToolTipText("sacuvaj trenutnu proceduru");
	saveButton.setBackground(UIManager.getColor("OptionPane.background"));
	saveButton.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			saveButtonActionPerformed(e);
		}
	});
	add(saveButton, cc.xywh(1, 3, 1, 1, CellConstraints.RIGHT, CellConstraints.CENTER));

	//---- parseButton ----
	parseButton.setToolTipText("parsiraj i kompajliraj");
	parseButton.setIcon(new ImageIcon("resized icons\\debug.png"));
	parseButton.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			parseButtonActionPerformed(e);
		}
	});
	add(parseButton, cc.xywh(3, 3, 1, 1, CellConstraints.CENTER, CellConstraints.CENTER));

	//---- runButton ----
	runButton.setToolTipText("izvrsi odmah");
	runButton.setIcon(new ImageIcon("resized icons\\Run.png"));
	runButton.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			runButtonActionPerformed(e);
		}
	});
	add(runButton, cc.xywh(5, 3, 1, 1, CellConstraints.CENTER, CellConstraints.CENTER));

	//---- previousStep ----
	previousStep.setToolTipText("vrati se u nazad");
	previousStep.setIcon(new ImageIcon("resized icons\\undo.png"));
	previousStep.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			previousStepActionPerformed(e);
		}
	});
	add(previousStep, cc.xywh(7, 3, 1, 1, CellConstraints.CENTER, CellConstraints.CENTER));

	//---- nextStepButton ----
	nextStepButton.setToolTipText("korak po korak izvrsavanje");
	nextStepButton.setIcon(new ImageIcon("resized icons\\redo.png"));
	nextStepButton.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			nextStepButtonActionPerformed(e);
		}
	});
	add(nextStepButton, cc.xywh(9, 3, 1, 1, CellConstraints.CENTER, CellConstraints.CENTER));

	//---- deleteProgramButton ----
	deleteProgramButton.setToolTipText("brishe trenutni program");
	deleteProgramButton.setIcon(new ImageIcon("resized icons\\delete.png"));
	deleteProgramButton.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			deleteProgramButtonActionPerformed(e);
		}
	});
	add(deleteProgramButton, cc.xy(11, 3));

	//---- currentProgramLabel ----
	currentProgramLabel.setFont(new Font("Times New Roman", Font.BOLD, 18));
	currentProgramLabel.setForeground(Color.blue);
	add(currentProgramLabel, cc.xy(13, 3));

	//---- helpButton ----
	helpButton.setToolTipText("pomoc");
	helpButton.setIcon(new ImageIcon("resized icons\\help_icon.png"));
	helpButton.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			helpButtonActionPerformed(e);
		}
	});
	add(helpButton, cc.xywh(15, 3, 1, 1, CellConstraints.CENTER, CellConstraints.CENTER));

	//---- infoButton ----
	infoButton.setToolTipText("informacije o programu");
	infoButton.setIcon(new ImageIcon("resized icons\\info.png"));
	add(infoButton, cc.xy(17, 3));
	add(separator3, cc.xywh(1, 5, 17, 1));

	//======== scrollPane1 ========
	{
		scrollPane1.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);

		//---- codeArea ----
		codeArea.setForeground(Color.blue);
		codeArea.setFont(new Font("Monospaced", Font.BOLD, 16));
		codeArea.setBackground(UIManager.getColor("InternalFrame.inactiveTitleForeground"));
		codeArea.addCaretListener(new CaretListener() {
			public void caretUpdate(CaretEvent e) {
				codeAreaCaretUpdate(e);
			}
		});
		codeArea.addKeyListener(new KeyAdapter() {
			@Override
			public void keyPressed(KeyEvent e) {
				codeAreaKeyPressed(e);
			}
		});
		codeArea.addPropertyChangeListener(new PropertyChangeListener() {
			public void propertyChange(PropertyChangeEvent e) {
				codeAreaPropertyChange(e);
			}
		});
		codeArea.addInputMethodListener(new InputMethodListener() {
			public void caretPositionChanged(InputMethodEvent e) {}
			public void inputMethodTextChanged(InputMethodEvent e) {
				codeAreaInputMethodTextChanged(e);
			}
		});
		codeArea.addVetoableChangeListener(new VetoableChangeListener() {
			public void vetoableChange(PropertyChangeEvent e)
				throws PropertyVetoException
			{
				codeAreaVetoableChange(e);
			}
		});
		scrollPane1.setViewportView(codeArea);
	}
	add(scrollPane1, cc.xywh(1, 7, 17, 1, CellConstraints.DEFAULT, CellConstraints.FILL));

	//---- errorLabel ----
	errorLabel.setFont(errorLabel.getFont().deriveFont(errorLabel.getFont().getStyle() | Font.BOLD, errorLabel.getFont().getSize() + 3f));
	errorLabel.setForeground(Color.red);
	add(errorLabel, cc.xywh(1, 9, 17, 1, CellConstraints.FILL, CellConstraints.FILL));
	add(separator1, cc.xywh(1, 11, 17, 1));

	//======== scrollPane3 ========
	{

		//---- registerTable ----
		registerTable.setAutoResizeMode(JTable.AUTO_RESIZE_OFF);
		registerTable.setBackground(Color.gray);
		registerTable.setFont(new Font("Monospaced", Font.BOLD, 20));
		registerTable.setForeground(Color.white);
		scrollPane3.setViewportView(registerTable);
	}
	add(scrollPane3, cc.xywh(1, 13, 15, 1));

	//---- setRegisterButton ----
	setRegisterButton.setToolTipText("potvrdi sadrzaj registra");
	setRegisterButton.setIcon(new ImageIcon("resized icons\\check.png"));
	setRegisterButton.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			setRegisterButtonActionPerformed(e);
		}
	});
	add(setRegisterButton, cc.xywh(17, 13, 1, 1, CellConstraints.LEFT, CellConstraints.CENTER));
	// //GEN-END:initComponents
    }

    // JFormDesigner - Variables declaration - DO NOT MODIFY
    // //GEN-BEGIN:variables
    // Generated using JFormDesigner Evaluation license - aca kare
    private JMenuBar menuBar1;
    private JMenu openMenu;
    private JButton saveButton;
    private JButton parseButton;
    private JButton runButton;
    private JButton previousStep;
    private JButton nextStepButton;
    private JButton deleteProgramButton;
    private JLabel currentProgramLabel;
    private JButton helpButton;
    private JButton infoButton;
    private JComponent separator3;
    private JScrollPane scrollPane1;
    private JTextArea codeArea;
    private JLabel errorLabel;
    private JComponent separator1;
    private JScrollPane scrollPane3;
    private JTable registerTable;
    private JButton setRegisterButton;
    // JFormDesigner - End of variables declaration //GEN-END:variables
    public void update(Observable arg0, Object arg1) {
	if (arg1 == ProgramConstants.INSTRUCTIONS_ARRAY_SET) {
	    updateCodeArea();
	}
	if (arg1 == ProgramConstants.REGISTER_STATE_CHANGED) {
	    updateRegisterArea();
	}
	if (arg1 == ProgramConstants.INSTRUCTION_CHANGED) {
	    updateCurrentInstructionViews();
	}
	if (arg1 == ProgramConstants.MASTER_REFRESH_WHOLE_MODEL_LOADED) {
	    updateModel();
	}

    }

    private void updateModel() {
	System.out.println("Updating model");
	currentProgramLabel.setText(ProgramState.getInstance().getCurrentWorkingProgram());
	updateCodeArea();
	updateRegisterArea();
	updateCurrentInstructionViews();
	updateSavedProcedureView();
    }

    private void updateCodeArea() {

	codeArea.setText("");
	if (controller.getModel().getInstructions() != null) {
	    StringBuffer buff = new StringBuffer();
	    Instruction[] instructions = controller.getModel().getInstructions();
	    for (int i = 0; i < instructions.length; i++) {
		buff.append(MessageFormat.format("{0,number, ####}:        {1};\n", new Object[] { i, instructions[i] }));
	    }
	    codeArea.setText(buff.toString());
	    codeArea.setCaretPosition(0);
	}
    }

    private void updateRegisterArea() {
	// notification about divergence
	if (controller.isDivergenceIndicator()) {
	    errorLabel.setText("Bilo je divergencije u izvrsavanju.");
	} else {
	    errorLabel.setText("Nema tragova divergencije za sada");
	}
	MyTableModel tableModel = new MyTableModel();
	Register register = controller.getModel().getRegister();
	register.addObserver(this);
	Object[] row = new Object[register.length()];
	Object[] fields = new Object[register.length()];
	for (int i = 0; i < register.length(); i++) {
	    fields[i] = ProgramConstants.REGISTER_PREFIX + i;
	    row[i] = register.getValueAt(i);
	}
	tableModel.addColumns(fields);
	for (int i = 0; i < registerTable.getColumnCount(); i++) {
	    registerTable.getColumnModel().getColumn(i).setPreferredWidth(ProgramConstants.REGSITER_WIDTH);
	    registerTable.getColumnModel().getColumn(i).setMaxWidth(ProgramConstants.REGSITER_WIDTH + 10);
	}
	tableModel.addRow(row);
	registerTable.setModel(tableModel);
    }

    private void updateCurrentInstructionViews() {
	codeArea.grabFocus();
	int insNum = controller.getModel().getCurrentInstruction();
	int startPos = 0;
	try {
	    startPos = codeArea.getLineStartOffset(insNum);
	} catch (BadLocationException e) {
	    // TODO Auto-generated catch block
	    e.printStackTrace();
	}
	codeArea.setCaretPosition(startPos);
    }

    private void updateSavedProcedureView() {
	TreeMap<String, Procedure> urmPrograms = controller.getUrmPrograms();
	Vector<String> messages = new Vector<String>(urmPrograms.size());
	Vector<String> toolTips = new Vector<String>(urmPrograms.size());
	Iterator<String> it = urmPrograms.keySet().iterator();
	String temp;
	// collecting info on stored procedures
	while (it.hasNext()) {
	    temp = it.next();
	    messages.add(temp);
	    toolTips.add(urmPrograms.get(temp).getArgs() + " arguments\n" + urmPrograms.get(temp).getDescription());
	}
	openMenu.removeAll();
	JMenuItem[] temps = new JMenuItem[messages.size()];
	for (int i = 0; i < messages.size(); i++) {
	    temps[i] = new JMenuItem(messages.get(i));
	    temps[i].setActionCommand(messages.get(i));
	    temps[i].setToolTipText(toolTips.get(i));
	    temps[i].addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent arg0) {
		    try {
			Procedure proc = getController().openProcedure(arg0.getActionCommand());
			controller.setModel(new UrmModel(proc, new Register(ProgramConstants.REGISTER_SIZE)), getInstance(getController().getModel()));
			controller.getModel().masterRefresh();
		    } catch (UrmException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		    }
		}
	    });
	    openMenu.add(temps[i]);
	}
    }

    public static UrmController getController() {
	return controller;
    }
}
